%{expand: %%define kver %(rpm -q --qf '%%{version}' kernel-source | head -1)}

Summary: System wide profiler for ix86 processors.
Name: oprofile
# XXX internal version is 0.4cvs but let's insure upgradeability
Version: 0.3
Release: 0.20020806
License: GPL
Group: Development/System
#
# XXX the source repository path from which the tar ball was generated.
Source: :pserver:anonymous@cvs.oprofile.sourceforge.net:/cvsroot/oprofile/%{name}-0.4cvs-20020806.tar.gz
Patch0: oprofile-0.4cvs-jbj.patch
Patch1: oprofile-0.3cvs-wec.patch
Patch2: oprofile-0.4cvs-wec2.patch
#Patch3: oprofile-0.3cvs-wec3.patch
Patch4: oprofile-0.3cvs-ia64.patch
Patch5: oprofile-0.3cvs-warn_error.patch
#Patch6: oprofile-0.3cvs-new.patch
Patch7: oprofile-0.4cvs-hack.patch
#Patch8: oprofile-0.3cvs-hz.patch
#Patch9: oprofile-0.3cvs-guess.patch
Patch10: oprofile-0.3cvs-guess2.patch
Patch11: oprofile-0.3cvs-ia64dummy.patch
#Patch12: oprofile-0.3cvs-nr_counter.patch
Patch13: oprofile-0.3cvs-ia64arch.patch
Patch14: oprofile-0.4cvs-order.patch
URL: http://oprofile.sf.net
ExclusiveArch: %{ix86} ia64
BuildPreReq: kernel-source
BuildPreReq: qt-devel
BuildPreReq: libxslt
BuildPreReq: docbook-style-xsl

#
# XXX adjust to taste, turn on when the kernel has matching Provide:
# Requires: kernel(oprofile) = 1.2-3
# XXX but for now let's use the specific kernel version.
Requires: kernel = %{kver}
BuildRoot: %{_tmppath}/%{name}-root

%description
oprofile is a profiling system for x86 systems running Linux 2.2/2.4.
Profiling runs transparently during the background, and profile data
can be collected at any time. oprofile makes use of the hardware performance
counters provided on Intel P6, and AMD Athlon family processors, and can use
the RTC for profiling on othe x86 processor types.

See the HTML documentation for further details.

%prep
%setup -q -n %{name}-0.4cvs
%patch0 -p1 -b .jbj
%patch1 -p1 -b .wec
%patch2 -p1 -b .wec2
#%patch3 -p1 -b .wec3
%patch4 -p1 -b .ia64
%ifarch ia64
%patch5 -p1 -b .warn_error
%endif
#%patch6 -p1 -b .new
%patch7 -p1 -b .hack
#%patch8 -p1 -b .hz
#%patch9 -p1 -b .guess
%patch10 -p1 -b .guess2
%patch11 -p1
#%patch12 -p1 -b .nr_counter
%patch13 -p1 -b .ia64arch
%patch14 -p1 -b .order
./autogen.sh

%build
%ifarch %{ix86}
QTDIR=/usr/lib/qt3;     export QTDIR
%endif

# XXX shorten when autoconf gets sorted out
KVER="%{kver}";		export KVER
./configure --with-linux=`echo /usr/src/linux-$KVER-*` \
        --host=%{_host} --target=%{_target_platform} --build=%{_build} \
	--program-prefix= \
        --prefix=%{_prefix} \
        --exec-prefix=%{_exec_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --sysconfdir=%{_sysconfdir} \
        --datadir=%{_datadir} \
        --includedir=%{_includedir} \
        --libdir=%{_libdir} \
        --libexecdir=%{_libexecdir} \
        --localstatedir=%{_localstatedir} \
        --sharedstatedir=%{_sharedstatedir} \
        --mandir=%{_mandir} \
        --infodir=%{_infodir}

make

%install
rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1

make DESTDIR=${RPM_BUILD_ROOT} install

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%doc doc/oprofile.html

%{_bindir}/*
%{_mandir}/man1/*

%changelog
* Tue Aug 06 2002 Will Cohen <wcohen@redhat.com>
- Change to avoid assumption on executable name

* Fri Aug 02 2002 Will Cohen <wcohen@redhat.com>
- Move to 0.4cvs sources.

* Mon Jul 29 2002 Will Cohen <wcohen@redhat.com>
- localize nr_counter code
- add ia64 arch
- guess path to vmlinux.

* Sun Jul 28 2002 Will Cohen <wcohen@redhat.com>
- adjust structure to fit ia64 oprofile module.

* Thu Jul 25 2002 Will Cohen <wcohen@redhat.com>
- recognize ia64 cpu and events.

* Tue Jul 23 2002 Will Cohen <wcohen@redhat.com>
- changes to turn of warning as error on ia64.

* Tue Jul 23 2002 Will Cohen <wcohen@redhat.com>
- changes to allow compilation on ia64.

* Mon Jul 22 2002 Will Cohen <wcohen@redhat.com>
- pick better Red Hat Linux default image file in /boot.

* Tue Jul 14 2002 Will Cohen <wcohen@redhat.com>
- use older OProfile 0.2 kernel<->daemon API.

* Tue Jul 11 2002 Will Cohen <wcohen@redhat.com>
- avoid oprof_start installing the oprofile module

* Tue Jul 02 2002 Will Cohen <wcohen@redhat.com>
- avoid building and installing the oprofile module

* Tue May 28 2002 Jeff Johnson <jbj@redhat.com>
- create package.
